
import 'package:dio/dio.dart';
import 'package:fawaterk_payment/response/fawaterk_default_response.dart';
import 'package:fawaterk_payment/response/fawaterk_error_response.dart';
import 'package:fawaterk_payment/response/fawaterk_fawry_response.dart';
import 'package:fawaterk_payment/response/fawaterk_mastercard_response.dart';
import 'package:fawaterk_payment/response/fawaterk_meeza_response.dart';
import 'package:fawaterk_payment/response/fawaterk_response_interface.dart';

class FawaterkResponse
{
  int? methodId;
  Response? response;

  FawaterkResponse({
    required this.response,
    this.methodId,
  });

  Response? respondWithMap()
  {
    return response;
  }

  FawaterkResponseInterface? respondWithError()
  {
    return FawaterkErrorResponse(response: response!.data);
  }

  FawaterkResponseInterface? respond()
  {
    if (response == null) {
      return FawaterkErrorResponse();
    }

    FawaterkResponseInterface? fawaterkResponse;

    switch (methodId) {
      case 2:
        fawaterkResponse = FawaterkMasterCardResponse(response: response!.data);
      case 3:
        fawaterkResponse = FawaterkFawryResponse(response: response!.data);
      case 4:
        fawaterkResponse = FawaterkMeezaResponse(response: response!.data);
      default:
        fawaterkResponse = FawaterkDefaultResponse(response: response!.data);
    }

    return fawaterkResponse;
  }
}
